/* 
 * place user-defined return codes after TT_TRACE_RETURN_CODES and before
 * TT_TRACE_MAX_RETURN_CODE_VALUE
 */
#define TT_TRACE_RETURN_CODES               \
    Token(TT_SUCCESS),                       \
    Token(TT_FAILED),                        \
    Token(TT_UNKNOWN_ELEMENT_TYPE),          \
    Token(TT_FAILED_TO_CREATE_CHILD_ELEMENT), \
    Token(TT_FAILED_TO_CREATE_NEW_ELEMENT), \
    Token(TT_FAILED_TO_INFLATE_SYNTAX_ELEMENT_DATA), \
    Token(TT_FAILED_TO_NAME_CHILD_ELEMENT), \
    Token(TT_FAILED_TO_SET_CHILD_ELEMENT_TYPE), \
    Token(TT_SYNTAX_ELEMENT_SERIALISATION_FAILURE), \
    Token(TT_FAILED_TO_LOCATE_SYNTAX_ELEMENT), \
    Token(TT_INVALID_ATTRIBUTE_INITIALISATION_VALUE_SPECIFIED), \
    Token(TT_TERMINAL_DOES_NOT_EXIST),       \
    Token(TT_TERMINAL_NOT_ATTACHED),         \
    Token(TT_PROPAGATION_EXCEPTION),         \
	Token(TT_CORRELID_NOT_FOUND),            \
	Token(TT_AGGREGATE_INSTANCE_NOT_FOUND),  \
	Token(TT_AGGREGATE_INSTANCE_TIMED_OUT),  \
	Token(TT_MESSAGE_ID_NOT_FOUND),          \
    Token(TT_ELEMENT_HAS_NO_VALUE), \
    Token(TT_ELEMENT_DATA_CONTAINS_NULL_DATA_CHARACTER), \
	Token(TT_FAILED_TO_SWAP_MESSAGE_REPLY_DETAILS), \
	Token(TT_FAILED_TO_SWAP_CORREL_AND_MSG_IDS), \
	Token(TT_ELEMENT_NOT_FOUND),             \
	Token(TT_ELEMENT_VALUE_NOT_RETRIEVED),   \
	Token(TT_FAILED_TO_GET_REPLY_TO_QUEUE_FROM_MESSAGE), \
	Token(TT_FAILED_TO_GET_REPLY_TO_QUEUE_MANAGER_FROM_MESSAGE), \
	Token(TT_FAILED_TO_SET_REPLY_TO_QUEUE_IN_MESSAGE), \
	Token(TT_FAILED_TO_SET_FORMAT_IN_MESSAGE), \
	Token(TT_FAILED_TO_SET_REPLY_TO_QUEUE_MANAGER_IN_MESSAGE), \
	Token(TT_FAILED_TO_SET_ID_IN_MESSAGE), \
	Token(TT_PROPAGATION_ERROR),             \
	Token(TT_FAILED_TO_CREATE_NEW_MESSAGE),  \
	Token(TT_FAILED_TO_CREATE_NEW_MESSAGE_ID),  \
	Token(TT_FAILED_TO_SERIALIZE_MESSAGE),   \
	Token(TT_FAILED_TO_GET_MESSAGE_LENGTH),   \
	Token(TT_FAILED_TO_GET_MACHINE_HARDWARE_ADDRESS),   \
	Token(TT_INVALID_ELEMENT_TYPE_SPECIFIED), \
	Token(TT_BUFFER_TOO_SMALL),               \
	Token(TT_FAILED_TO_GET_MESSAGE_ROOT),    \
	Token(TT_FAILED_TO_COPY_MESSAGE),        \
	Token(TT_FAILED_TO_GET_MESSAGE_BODY),    \
	Token(TT_FAILED_TO_GET_MESSAGE_MQMD),    \
	Token(TT_FAILED_TO_GET_MESSAGE_FORMAT),    \
	Token(TT_FAILED_TO_DELETE_MESSAGE_BODY), \
	Token(TT_FAILED_TO_CREATE_MESSAGE_BODY), \
	Token(TT_INVALID_OUTPUT_BUFFER_LENGTH),  \
	Token(TT_FAILED_TO_CREATE_DESTINATION_LIST),  \
	Token(TT_FAILED_TO_SET_DESTINATION_LIST),  \
	Token(TT_PUT_APPL_NAME_NOT_FOUND),  \
	Token(TT_LOG_ERROR),  \
	Token(TT_FAILED_TO_CONNECT_TO_QUEUE_MANAGER),  \
	Token(TT_FAILED_TO_OPEN_RECOVERY_QUEUE),  \
	Token(TT_FAILED_TO_WRITE_LOG_RECORD),  \
	Token(TT_FAILED_TO_READ_LOG_RECORD),  \
	Token(TT_FAILED_TO_ACCESS_RECOVERY_MEDIA),  \
	Token(TT_RECOVERED_REPLY_MESSAGE_MISSING_REQUEST),  \
	Token(TT_UNEXPECTED_REPLY_MESSAGE_FOUND_IN_LOG),  \
	Token(TT_UNEXPECTED_FINISH_MESSAGE_FOUND_IN_LOG),  \
    Token(TT_FAILED_TO_GET_PARENT_ELEMENT), \
    Token(TT_TRACE_MAX_RETURN_CODE_VALUE)
